/***********************************************************
*
*	51ƬõĺĶ壬ع
*
*	Author:		Сƻ
*	CreateDate:	20151211
*
*	UpdateDate:	20151212
*************************************************************/


#include <reg52.h>
#include <FunctionsLib.h>

/****λ*************/
sbit startKey = P3^2;   //ⲿж
sbit saveKey = P3^3;    //ⲿж
sbit viewKey = P3^4;
sbit resetKey = P3^5;
sbit led = P1^0; //LED

/******************/
u8 bitA,bitB,bitC; //abcֱӦӣ룬(10)
u8 count; //(ʱ/жĴ)
u8 startFlag;  //ʼ־ Ϊ0ʾûмλ1ʾڼ
u8 saveData[5][3]; //趨´洢ʱǰʾֵɴ洢5
u8 index = 0;   //洢

//ʼʱ/
void init_Timer(u8 th0,u8 tl0);
//洢ãÿ1Խλʱ0
void index_add_Set();
//ʼ/ͣ¼
void startKey_event();
//洢¼
void saveKey_event();
//鿴¼
void viewKey_event();
//λ¼
void resetKey_event();

void main()
{
   
    
    init_digital_latch();
    
    init_Timer(0xd8,0xf0); //10ж
    
    while(1)
    {
		
		startKey_event();
		if(startFlag)
		{
			//ݿʼ־ȥ趨ʱ
			TR0 = 1;
			saveKey_event();
		}
		else
		{
			TR0 = 0;
			viewKey_event();
			resetKey_event();
		}
      
		digital_view_stopwatch(bitA,bitB,bitC);
		led = 1;
    }
}



/*
ʼʱ/
[th0] ֵ
[tl0] ֵ
*/
void init_Timer(u8 th0,u8 tl0)
{
    //ƶʱ/
    TMOD = 0x01; //ģʽ1 16λ
    //TH0 = (65536 - 10000)/256;  //12Mhz 
    //TL0 = (65536- 10000)%256;
    
    TH0 = th0;
    TL0 = tl0;
    
    /******
    EA = 1;
    ET0 = 1;  //ʱ/0жλ
    *******/    //ΪIEԱλѰַԿһд  
    
    IE = 0x82;   //1000 0010  
}


/*
ʱ/ʱ
*/
void timer_service() interrupt 1
{
    TH0 = 0xd8;
    TL0 = 0xf0; 

    bitC++;
    
    if(bitC == 100)
    {
        bitB++;
        bitC = 0;
    }
    
    if(bitB == 60)
    {
        bitA++;
        bitB = 0;
    }
    
    if(bitA == 60)
    {
        bitA = bitB = bitC = 0;
    }
}

/*
ʼ/ͣ¼
*/
void startKey_event()
{
    //
    if(startKey == 0)
    {
        delay(5);

        if(startKey == 0)
		{
			startFlag = ~startFlag;
			led = 0;
			
		}
		while(!startKey)
		{
			digital_view_stopwatch(bitA,bitB,bitC);
		}
    }
}

/*
洢¼
*/
void saveKey_event()
{       
    //
    if(saveKey ==0)
    {
        delay(5);
        if(saveKey ==0 )
        {			
			saveData[index][0] = bitA;
			saveData[index][1] = bitB;
			saveData[index][2] = bitC;
			index = index == 4 ? 0 : index + 1;
			led = 0;	
			
        }
        while(!saveKey)
		{
			digital_view_stopwatch(bitA,bitB,bitC);
		}
		
    }
}

/*
鿴¼
*/
void viewKey_event()
{
	if(viewKey == 0)
    {   
        delay(5);
        
        if(viewKey == 0)
        { 
			index = (index == 0) ? 4 : index-1;
			
            bitA = saveData[index][0];
            bitB = saveData[index][1];
            bitC = saveData[index][2];
			led = 0;
			
        }
		while(!viewKey)
		{
			digital_view_stopwatch(bitA,bitB,bitC);
		}
	}
}

/*
λ¼
*/
void resetKey_event()
{
	u8 x;
	if(resetKey == 0)
    {   
        delay(5);
        
        if(resetKey == 0)
        { 
			index =0;
            bitA = bitB = bitC = 0;
			for(x = 0;x< 5;x++)
				saveData[x][0] = saveData[x][1] = saveData[x][2] = 0;
			
			led = 0;
			
        }
        while(!resetKey)
		{
			digital_view_stopwatch(bitA,bitB,bitC);
		}
	}
}










